package cz.mendelu.dnaAnalyser.sequence.annotation;

import cz.mendelu.dnaAnalyser.sequence.annotation.AnnotationController;
import cz.mendelu.dnaAnalyser.utils.api.ApiRestTemplate;
import cz.mendelu.dnaAnalyser.utils.controller.TagModifyRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.http.HttpStatus;
import org.springframework.test.context.ActiveProfiles;
import spock.lang.Ignore;
import spock.lang.Specification;

import java.util.UUID;

import static org.springframework.boot.test.context.SpringBootTest.WebEnvironment.RANDOM_PORT;

@Ignore
@SpringBootTest(webEnvironment = RANDOM_PORT)
@ActiveProfiles("test")
class AnnotationControllerTest extends Specification {

    @Autowired
    ApiRestTemplate api

    def setup() {
        api.authentication('user@mendelu.cz', 'user')
    }

    def "GET:/api/sequence/annotation/{id} Get one annotation by ID."(){
        setup:
        def id = UUID.fromString("987acc67-5714-47b1-b56f-1dc56ded7c87")

        when:
        def response = api.get("/api/sequence/annotation/${id}")

        then:
        response.status == HttpStatus.OK.value()

    }

    def "POST:/api/sequence/annotation Create annotation from sequence."() {
        given:
        def request = new AnnotationController.AnnotationCreateRequest(
                sequence: UUID.fromString('987acc67-5714-47b1-b56f-1dc56ded7c87')
        )

        when:
        def response = api.post("/api/annotation", request)

        then:
        response.status == HttpStatus.CREATED.value()
    }

}
